<template>
    <nav class="bg-white shadow">
        <div class="mx-auto container px-6 py-2 xl:py-0">
            <div class="flex items-center justify-between">
                <div class="inset-y-0 left-0 flex items-center xl:hidden">
                    <div class="inline-flex items-center justify-center p-2 rounded-md text-gray-700 hover:text-gray-100 focus:outline-none transition duration-150 ease-in-out">
                        <div class="visible xl:hidden">
                            <ul class="p-2 border-r bg-white absolute rounded left-0 right-0 shadow mt-8 md:mt-8 hidden z-50">
                                <li class="flex xl:hidden cursor-pointer text-gray-600 text-sm leading-3 tracking-normal mt-2 py-2 hover:text-indigo-700 focus:text-indigo-700 focus:outline-none">
                                  <router-link to="/catalog">
                                    <div class="flex items-center">
                                      <font-awesome-icon icon="book" size="2x"/>
                                      <span class="ml-2 font-bold">Catalogue</span>
                                    </div>
                                  </router-link>
                                </li>
                                <li class="xl:hidden flex-col cursor-pointer text-gray-600 text-sm leading-3 tracking-normal py-2 hover:text-indigo-700 focus:text-indigo-700 focus:outline-none flex justify-center" @click="dropdownHandler($event)">
                                  <div class="flex items-center">
                                    <router-link to="/studio">
                                      <font-awesome-icon icon="puzzle-piece" size="2x"/>
                                      <span class="ml-2 font-bold">Studios</span>
                                    </router-link>
                                  </div>
                                </li>
                                <li v-if="this.user ? user.roles.includes('ROLE_STUDIO') : false" class="xl:hidden flex-col cursor-pointer text-gray-600 text-sm leading-3 tracking-normal py-2 hover:text-indigo-700 focus:text-indigo-700 focus:outline-none flex justify-center" @click="dropdownHandler($event)">
                                  <div class="flex items-center">
                                    <router-link to="/dashboard">
                                      <font-awesome-icon icon="user" size="2x"/>
                                      <span class="ml-2 font-bold">Dashboard</span>
                                    </router-link>
                                  </div>
                                </li>
                                <li v-if="this.user ? user.roles.includes('ROLE_SUPER_ADMIN') : false" class="xl:hidden flex-col cursor-pointer text-gray-600 text-sm leading-3 tracking-normal py-2 hover:text-indigo-700 focus:text-indigo-700 focus:outline-none flex justify-center" @click="dropdownHandler($event)">
                                  <div class="flex items-center">
                                    <router-link to="/admin">
                                      <font-awesome-icon icon="user-cog" size="2x"/>
                                      <span class="ml-2 font-bold">Admin</span>
                                    </router-link>
                                  </div>
                                </li>
                                <li v-if="this.user != null" class="text-gray-600 text-sm leading-3 tracking-normal mt-2 py-2 hover:text-indigo-700 flex items-center focus:text-indigo-700 focus:outline-none">
                                    <div class="flex items-center">
                                        <div class="w-12 cursor-pointer flex text-sm border-2 border-transparent rounded focus:outline-none focus:border-white transition duration-150 ease-in-out">
                                            <img class="rounded h-10 w-10 object-cover" :src="profilePhoto" alt="logo" />
                                        </div>
                                        <p class="text-sm ml-2 cursor-pointer">{{this.user.username}}</p>
                                        <div class="sm:ml-2 text-white relative">
                                            <svg xmlns="http://www.w3.org/2000/svg" class="icon icon-tabler icon-tabler-chevron-down cursor-pointer" width="20" height="20" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" fill="none" stroke-linecap="round" stroke-linejoin="round">
                                                <path stroke="none" d="M0 0h24v24H0z"></path>
                                                <polyline points="6 9 12 15 18 9"></polyline>
                                            </svg>
                                        </div>
                                    </div>
                                </li>
                                <li v-if="this.user != null" class="xl:hidden cursor-pointer text-gray-600 text-sm leading-3 tracking-normal py-2 hover:text-indigo-700 flex items-center focus:text-indigo-700 focus:outline-none">
                                  <div class="flex items-center">
                                    <router-link to="/profil">
                                      <font-awesome-icon icon="user" size="2x"/>
                                      <span class="ml-2">Profil</span>
                                    </router-link>
                                  </div>
                                </li>
                                <li v-if="this.user != null" class="xl:hidden cursor-pointer text-gray-600 text-sm leading-3 tracking-normal py-2 hover:text-indigo-700 flex items-center focus:text-indigo-700 focus:outline-none">
                                  <div class="flex items-center" @click="disconnection()">
                                    <font-awesome-icon icon="sign-out-alt" size="2x"/>
                                    <span class="ml-2">Déconnexion</span>
                                  </div>
                                </li>
                                <li v-if="this.user == null" class="cursor-pointer text-gray-600 text-sm leading-3 tracking-normal py-2 hover:text-indigo-700 focus:text-indigo-700 focus:outline-none">
                                  <router-link to="/register">
                                    <div class="flex items-center">
                                        <font-awesome-icon icon="pen-square" size="2x"/>
                                        <span class="ml-2 font-bold">Inscription</span>
                                    </div>
                                  </router-link>
                                </li>
                                <li v-if="this.user == null" class="cursor-pointer text-gray-600 text-sm leading-3 tracking-normal py-2 hover:text-indigo-700 focus:text-indigo-700 focus:outline-none">
                                  <router-link to="/login">
                                    <div class="flex items-center">
                                        <font-awesome-icon icon="sign-in-alt" size="2x"/>
                                        <span class="ml-2 font-bold">Connexion</span>
                                    </div>
                                  </router-link>
                                </li>
                            </ul>
                            <svg @click="MenuHandler($event, true)" aria-haspopup="true" aria-label="Main Menu" xmlns="http://www.w3.org/2000/svg" class="show-m-menu icon icon-tabler icon-tabler-menu" width="28" height="28" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" fill="none" stroke-linecap="round" stroke-linejoin="round">
                                <path stroke="none" d="M0 0h24v24H0z"></path>
                                <line x1="4" y1="8" x2="20" y2="8"></line>
                                <line x1="4" y1="16" x2="20" y2="16"></line>
                            </svg>
                            <div class="hidden close-m-menu text-gray-700" @click="MenuHandler($event, false)">
                                <svg aria-label="Close" xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" fill="none" stroke-linecap="round" stroke-linejoin="round">
                                    <path stroke="none" d="M0 0h24v24H0z" />
                                    <line x1="18" y1="6" x2="6" y2="18" />
                                    <line x1="6" y1="6" x2="18" y2="18" />
                                </svg>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="flex w-full sm:w-auto items-center sm:items-stretch justify-end sm:justify-start">
                    <router-link to="/">
                      <div class="flex items-center text-indigo-600">
                        <font-awesome-icon icon="box" size="2x"/>  
                        <h2 class="hidden sm:block text-base text-gray-700 font-bold leading-normal pl-3">Game Box</h2>
                      </div>
                    </router-link>
                </div>
                <div class="flex">
                    <div class="hidden xl:flex md:mr-6 xl:mr-16">
                        <router-link to="/catalog" class="flex px-5 items-center py-6 text-sm leading-5 text-gray-700 hover:bg-gray-100 focus:bg-gray-100 focus:outline-none transition duration-150 ease-in-out">
                          <span class="mr-2">
                              <font-awesome-icon icon="book" size="2x"/>
                          </span>
                          Catalogue
                        </router-link>
                        <router-link to="/studio" class="flex px-5 items-center py-6 text-sm leading-5 text-gray-700 hover:bg-gray-100 focus:bg-gray-100 focus:outline-none transition duration-150 ease-in-out">
                          <span class="mr-2">
                            <font-awesome-icon icon="puzzle-piece" size="2x"/>
                          </span>
                          Studios
                        </router-link>
                        <router-link v-if="this.user ? user.roles.includes('ROLE_SUPER_ADMIN') : false" to="/admin" class="flex px-5 items-center py-6 text-sm leading-5 text-gray-700 hover:bg-gray-100 focus:bg-gray-100 focus:outline-none transition duration-150 ease-in-out">
                          <span class="mr-2">
                            <font-awesome-icon icon="user-cog" size="2x"/>
                          </span>
                          Admin
                        </router-link>
                        <router-link v-if="this.user ? user.roles.includes('ROLE_STUDIO') : false" to="/dashboard" class="flex px-5 items-center py-6 text-sm leading-5 text-gray-700 hover:bg-gray-100 focus:bg-gray-100 focus:outline-none transition duration-150 ease-in-out">
                          <span class="mr-2">
                            <font-awesome-icon icon="user" size="2x"/>
                          </span>
                          Dashboard
                        </router-link>
                    </div>
                    <div v-if="this.user == null" class="hidden xl:flex items-center">
                        <div class="ml-6 grid grid-cols-2 gap-4">
                            <router-link to="/register">
                                <Button label="Insciption" />
                            </router-link>
                            <router-link to="/login">
                                <Button label="Connexion" color="yellow"/>
                            </router-link>
                        </div>
                    </div>
                    <div v-if="this.user != null" class="hidden xl:flex items-center z-50">
                        <div class="ml-6 relative">
                            <div class="flex items-center relative" @click="dropdownHandler($event)">
                                <ul class="p-2 w-40 border-r bg-white absolute rounded right-0 shadow top-0 mt-16 hidden">
                                    <li class="cursor-pointer text-gray-600 text-sm leading-3 tracking-normal py-2 hover:text-indigo-700 focus:text-indigo-700 focus:outline-none">
                                        <router-link to="/profil">
                                          <font-awesome-icon icon="user" size="2x"/>
                                          <span class="ml-2">Profil</span>
                                        </router-link>
                                    </li>
                                    <li class="cursor-pointer text-gray-600 text-sm leading-3 tracking-normal mt-2 py-2 hover:text-indigo-700 focus:text-indigo-700 focus:outline-none flex items-center">
                                      <router-link to="/help">
                                        <font-awesome-icon icon="question-circle" size="2x"/>
                                        <span class="ml-2">Centre Aide</span>
                                      </router-link>
                                    </li>
                                    <li @click="disconnection()" class="cursor-pointer text-gray-600 text-sm leading-3 tracking-normal mt-2 py-2 hover:text-indigo-700 flex items-center focus:text-indigo-700 focus:outline-none">
                                      <font-awesome-icon icon="sign-out-alt" size="2x"/>
                                      <span class="ml-2">Déconnexion</span>
                                    </li>
                                </ul>
                                <div class="cursor-pointer flex text-sm border-2 border-transparent rounded-full focus:outline-none focus:border-white transition duration-150 ease-in-out">
                                    <img class="rounded-full h-10 w-10 object-cover" :src="profilePhoto" alt="logo" />
                                </div>
                                <div class="ml-2 text-gray-600">
                                    <svg xmlns="http://www.w3.org/2000/svg" class="icon icon-tabler icon-tabler-chevron-down cursor-pointer" width="20" height="20" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" fill="none" stroke-linecap="round" stroke-linejoin="round">
                                        <path stroke="none" d="M0 0h24v24H0z"></path>
                                        <polyline points="6 9 12 15 18 9"></polyline>
                                    </svg>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </nav>
</template>

<script>
import Button from "./Button.vue"

export default {
    name: "Navbar",
    components: {
        Button
    },
    data() {
        return {
            profilePhoto: this.user ? `https://source.boringavatars.com/beam/120/${this.user.username}` : null,
        };
    },
    inject: ["user", "disconnection"],
    methods: {
        dropdownHandler(event) {
            let single = event.currentTarget.getElementsByTagName("ul")[0];
            single.classList.toggle("hidden");
        },
        MenuHandler(el, val) {
            let MainList = el.currentTarget.parentElement.getElementsByTagName("ul")[0];
            let closeIcon = el.currentTarget.parentElement.getElementsByClassName("close-m-menu")[0];
            let showIcon = el.currentTarget.parentElement.getElementsByClassName("show-m-menu")[0];
            if (val) {
                MainList.classList.remove("hidden");
                el.currentTarget.classList.add("hidden");
                closeIcon.classList.remove("hidden");
            } else {
                showIcon.classList.remove("hidden");
                MainList.classList.add("hidden");
                el.currentTarget.classList.add("hidden");
            }
        },
    },
};
</script>
